var data; var list; var error; var net; var pcrud; var sound;
var rows = {};
var bpbcm_barcode_map = {};

var commonStrings;
var catStrings;

//// parent interfaces may call this
function default_focus() { $('scanbox').focus(); }
////

function my_init() {
    try {
        netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect"); 

        commonStrings = $('commonStrings');
        patronStrings = $('patronStrings');

        if (typeof JSAN == 'undefined') {
            throw(
                commonStrings.getString('common.jsan.missing')
            );
        }

        JSAN.errorLevel = "die"; // none, warn, or die
        JSAN.addRepository('..');

        JSAN.use('util.error'); error = new util.error();
        JSAN.use('util.sound'); sound = new util.sound();
        JSAN.use('util.widgets');
        JSAN.use('util.functional');
        JSAN.use('util.list');
        JSAN.use('OpenILS.data'); data = new OpenILS.data();
        data.stash_retrieve();
        JSAN.use('util.network'); net = new util.network();
        dojo.require('openils.PermaCrud');
        pcrud = new openils.PermaCrud( { authtoken :ses() });

        init_menu();
        init_list();
        $('list_actions').appendChild( list.render_list_actions() );
        list.set_list_actions();
        populate_list();
        $('submit').addEventListener('command', function() { handle_submit(true); }, false);
        $('remove').addEventListener('command', function() { handle_remove(); }, false);
        $('change').addEventListener('command', function() { handle_change(); }, false);
        $('scanbox').addEventListener('keypress', handle_keypress, false);
        default_focus();

        if (typeof window.xulG == 'object' && typeof window.xulG.set_tab_name == 'function') {
            try { window.xulG.set_tab_name('Manage Multi-Home Items for Bib ' + xul_param('docid')); } catch(E) { alert(E); }
        }

    } catch(E) {
        alert('Error in manage_multi_home_items.js, my_init(): ' + E);
    }
}

function init_menu() {
    try {
        var ml = util.widgets.make_menulist(
            util.functional.map_list(
                data.list.bpt.sort( function(a,b) {
                    if (a.name().toUpperCase() < b.name().toUpperCase()) return -1;
                    if (a.name().toUpperCase() > b.name().toUpperCase()) return 1;
                    return 0;
                }),
                function(obj) {
                    return [ obj.name(), obj.id() ];
                }
            )
        );
        ml.setAttribute('id','bpt_menu');
        $('menu_placeholder').appendChild(ml);
    } catch(E) {
        alert('Error in manage_multi_home_items.js, init_menu(): ' + E);
    }
}

function init_list() {
    try {
        list = new util.list( 'list' );
        list.init( 
            {
                'retrieve_row' : function(params) {
                    if (params.row.my.bpbcm) {
                        params.row_node.setAttribute('retrieve_id',params.row.my.bpbcm.id());
                    }
                    params.on_retrieve(params.row);
                    return params.row;
                },
                'columns' : [
                    {
                        'id' : 'result',
                        'label' : 'Result',
                        'flex' : 1,
                        'primary' : false,
                        'hidden' : false,
                        'editable' : false, 'render' : function(my) { return my.result; }
                    }
                ].concat(
                    list.fm_columns('acp', {
                        '*' : { 'expanded_label' : false, 'hidden' : true },
                        'acp_barcode' : { 'hidden' : false },
                        'acp_opac_visible' : { 'hidden' : false },
                        'acp_holdable' : { 'hidden' : false }
                    })
                ).concat(
                    list.fm_columns('mvr', {
                        '*' : { 'expanded_label' : false, 'hidden' : true }, 
                        'mvr_title' : { 'hidden' : false },
                        'mvr_author' : { 'hidden' : false },
                        'mvr_isbn' : { 'hidden' : false },
                        'mvr_tcn' : { 'hidden' : false },
                        'mvr_id' : { 'hidden' : false }
                    })
                ).concat(
                    list.fm_columns('bpbcm', {
                        '*' : { 'expanded_label' : false, 'hidden' : true },
                        'bpbcm_peer_type' : {
                            'hidden' : false,
                            'render' : function(my) { return my.bpbcm ? data.hash.bpt[ my.bpbcm.peer_type() ].name() : ''; }
                        }
                    })
                )
            }
        );
    } catch(E) {
        alert('Error in manage_multi_home_items.js, init_list(): ' + E);
    }
}

function handle_keypress(ev) {
    try {
        if (ev.keyCode && ev.keyCode == 13) {
            handle_submit(true);
        }
    } catch(E) {
        alert('Error in manage_multi_home_items.js, handle_keypress(): ' + E);
    }
}

function handle_submit(create,my_bpbcm) {
    try {
        var barcode;
        if (create) {
            barcode = $('scanbox').value;
            $('scanbox').value = '';
            default_focus();
        }

        var placeholder_acp = new acp();
        placeholder_acp.barcode(barcode);
        var row_params = {
            'row' : {
                'my' : {
                    'acp' : placeholder_acp,
                    'bpbcm' : my_bpbcm
                }
            }
        };

        if (barcode && rows[barcode]) {
                var node = rows[barcode].my_node;
                var parentNode = node.parentNode;
                parentNode.removeChild( node );
                delete(rows[barcode]);
        }

        row_params = list.append(row_params);
        if (barcode) {
            rows[barcode] = row_params;
        }

        function handle_req(req) {
            try {
                var robj = req.getResultObject();
                row_params.row.my.result = 'Error';
                if (typeof robj.ilsevent != 'undefined') {
                    row_params.row.my.result = robj.textcode;
                } else {
                    rows[robj.copy.barcode()] = row_params;
                    if (row_params.row.my.bpbcm) {
                        bpbcm_barcode_map[ row_params.row.my.bpbcm.id() ] = robj.copy.barcode();
                    }

                    row_params.row.my.acp = robj.copy;
                    row_params.row.my.mvr = robj.mvr;

                    if (create && robj.mvr.doc_id() != xul_param('docid')) {
                        var new_bpbcm = new bpbcm();
                            new_bpbcm.isnew(1);
                            new_bpbcm.peer_type($('bpt_menu').value);
                            new_bpbcm.peer_record(xul_param('docid'));
                            new_bpbcm.target_copy(robj.copy.id());
                        pcrud.create(new_bpbcm, {
                            "onerror" : function(r) {
                                alert('here');
                                alert(js2JSON(r));
                            },
                            "oncomplete": function (r, objs) {
                                try {
                                    var obj = objs[0];
                                    if (obj) {
                                        row_params.row.my.result = 'Success';
                                        row_params.row.my.bpbcm = obj;
                                        bpbcm_barcode_map[ obj.id() ] = robj.copy.barcode();
                                    } else {
                                        row_params.row.my.result = 'Failed';
                                        sound.bad();
                                    }
                                    list.refresh_row( row_params );
                                } catch(E) {
                                    alert('Error in manage_multi_home_items.js, handle_submit, pcrud create oncomplete callback: ' + E);
                                }
                            }
                        });
                    } else {
                        if (robj.mvr.doc_id() != xul_param('docid')) {
                            row_params.row.my.result = 'Item linked to Bib';
                        } else {
                            row_params.row.my.result = 'Item native to Bib';
                        }
                    }
                }
                list.refresh_row( row_params );
            } catch(E) {
                alert('Error in manage_multi_home_items.js, handle_submit, acp details callback: ' + E);
            }
        }

        if (my_bpbcm) {
            net.simple_request(
                'FM_ACP_DETAILS', // FIXME: want this to be authoritative
                [ ses(), my_bpbcm.target_copy() ],
                handle_req
            );
        } else {
            net.simple_request(
                'FM_ACP_DETAILS_VIA_BARCODE.authoritative',
                [ ses(), barcode ],
                handle_req
            );
        }

    } catch(E) {
        alert('Error in manage_multi_home_items.js, handle_submit(): ' + E);
    }
}

function populate_list() {
    try {
        pcrud.search(
            'bpbcm',
            {
                peer_record : xul_param('docid')
            },
            {
                async : true,
                streaming : true,
                onerror : function(r) {
                        alert('Error in manage_multi_home_items.js, populate_list(), pcrud.search onerror: ' + r);
                },
                oncomplete : function() {
                },
                onresponse : function(r) {
                    try {
                        var my_bpbcm = openils.Util.readResponse(r);
                        if (typeof my_bpbcm.ils_event != 'undefined') { throw(my_bpbcm); }
                        handle_submit(false,my_bpbcm);
                    } catch(E) {
                        alert('Error in manage_multi_home_items.js, populate_list(), pcrud.search onresponse: ' + E);
                    }
                }
            }
        );

    } catch(E) {
        alert('Error in manage_multi_home_items.js, populate_list(): ' + E);
    }
}

function handle_change() {
    try {
        var node_list = list.retrieve_selection();
        var eligibles = [];
        for (var i = 0; i < node_list.length; i++) {
            if (node_list[i].hasAttribute('retrieve_id')) {
                eligibles.push( node_list[i].getAttribute('retrieve_id') );
            }
        }
        if (eligibles.length > 0) {
            if (window.confirm(
                eligibles.length == 1
                ? 'Change peer type on 1 selected item to ' + data.hash.bpt[ $('bpt_menu').value ].name()
                : 'Change peer type on ' + eligibles.length + ' selected items to '+ data.hash.bpt[ $('bpt_menu').value ].name())
            ) {
                var bpbcm_list = [];
                for (var i = 0; i < eligibles.length; i++) {
                    var obj = rows[ bpbcm_barcode_map[ eligibles[i] ] ].row.my.bpbcm;
                    obj.ischanged(1);
                    obj.peer_type( $('bpt_menu').value );
                    bpbcm_list.push( obj );
                }
                pcrud.update(
                    bpbcm_list, {
                        'async' : false,
                        'onerror': function(r) {
                            dump('onerror: ' + r + '\n');
                        },
                        'onresponse': function(r) {
                            dump('onresponse: ' + r + '\n');
                        },
                        'oncomplete': function(r,ids) {
                            dump('oncomplete: r = ' + r + '\n\tids = ' + js2JSON(ids) + '\n');
                            for (var i = 0; i < ids.length; i++) {
                                var bpbcm_id = ids[i];
                                try {
                                    rows[ bpbcm_barcode_map[ bpbcm_id ] ].row.my.bpbcm.peer_type( $('bpt_menu').value );
                                    rows[ bpbcm_barcode_map[ bpbcm_id ] ].row.my.result = 'Peer Type Updated';
                                    list.refresh_row( rows[ bpbcm_barcode_map[ bpbcm_id ] ] );
                                } catch(E) {
                                    alert('error in oncomplete: ' + E);
                                }
                            }
                        }
                    }
                );
            }
        }

    } catch(E) {
        alert('Error in manage_multi_home_items.js, handle_change(): ' + E);
    }
}
